/* Insert a New Element E into a Binary Search Tree T. */

#include <u.h>
#include <libc.h>
#include "TreeElement.h"
#include "Tree.h"
#include "Insert.h"

void insertTree( TreeElementType E, Tree *T )
/*  pre: T is a binary search tree */
/* post: E is in T and T is still a binary search tree */
/* NB. T is a reference parameter and the tree is changed as a side-effect */
 { if( *T == nil )
    { *T = (Tree)malloc(sizeof(Node)); /*new leaf*/
      (*T)->left = (*T)->right = (Tree)nil;                  /*L*/
//      TreeElementMove(E, &((*T)->elt));                       /*.*/
      TreeElementMove(E, ((*T)->elt));                       /*.*/
    }                                                         /*A*/
   else/*T not nil*/                                         /*l*/
      if( TreeElementLess( E, (*T)->elt) )                    /*l*/
         insertTree( E, &((*T)->left) );                      /*i*/
      else if( TreeElementLess((*T)->elt, E) )                /*s*/
         insertTree( E, &((*T)->right) );                     /*o*/
   /* else  equal, in this implementation do nothing */       /*n*/
 }/*insertTree*/

