/* Simple Lexical Analyser Routine */

#include <u.h>
#include <libc.h>
#include <stdio.h>
#include "TreeElement.h"
#include "Tree.h"
#include "Parser.h"



char word[11];  int len;  int ch;  int sy; /*parser state variables*/


void Error(char *msg) /* print error message and stop */
 { print("Error: %s (word=%s)(ch=%c)\n", msg, word, ch);  exits("Error");
 }/*Error*/


void insymbol()  /* Simple Lexical Analyser Routine */
 { strncpy(word, "?", 10);
   while( ch==' ' ) ch=getchar();
   len = 0;
   if( ch == '\n' )
      sy=eoExp;
   else
    { if( ch >= 'a' && ch <= 'z' ) /* alphanumeric */
       { while( ch >= 'a' && ch <= 'z' )
          { if(len <= 10)
             { word[len] = ch; len++; word[len] = 0; }
            ch=getchar();
          }
         sy=ident;
       }
      else/*not alphanumeric*/
       { word[0]=ch; word[1]=0; len=1;
         switch(ch)
          { case '+': sy=plusSy;  break;  case '-': sy=minusSy; break;
            case '*': sy=timesSy; break;  case '/': sy=overSy;  break;
            case '(': sy=openSy;  break;  case ')': sy=closeSy; break;
            default: Error("bad symbol"); 
          }/*switch*/
         ch=getchar();
    }  }
 }/*insymbol*/


void check( int symbol, char *errMsg ) /* check and skip specified symbol */
 { if( sy == symbol ) insymbol(); else Error(errMsg); }


Tree sequence(Tree NonTerminal(void), int symbols)              /*L*/
/* Parse  <NonTerminal> [ symbols <NonTerminal> ]*                .*/
 { Tree T;  char operator[11];                                  /*A*/
   T = NonTerminal();                                           /*l*/
   while( sy & symbols ) /* i.e. sy in symbols */               /*l*/
    { strncpy(operator, word, 10);                              /*i*/
      insymbol();                                               /*s*/
      T = forked(operator, T, NonTerminal());/* left associative. o*/
    }                                                           /*n*/
   return T;
 }/*sequence*/


Tree factor()                 /* the expression parser proper starts here */
 { Tree oprnd;
   if( sy == ident )
    { oprnd = forked(word, (Tree)nil, (Tree)nil);
      insymbol();
      return oprnd;
    }
   else if( sy == openSy )    /*  ( <expr> )  */
    { insymbol();
      oprnd = expr();
      check(closeSy, "missing )");
      return oprnd;
    }
   else Error("bad factor (operand)"); return nil;
 }/*factor*/


Tree term() { return sequence(factor, timesSy | overSy); }

Tree expr()  { return sequence(term, plusSy | minusSy); }


Tree parse()
 { Tree T;
   strncpy(word, "?", 10); len=0; ch=' '; insymbol(); /* initialise state */

   T = expr();

   check(eoExp, "incomplete");
   return T;
 }/*parse*/

/* Simple Expression Parser */
